﻿package utils{
	import flash.events.*;
	import flash.display.*;
	import com.senocular.utils.KeyObject;
	import flash.display.Stage;
	import flash.ui.Keyboard;
	public class helicopter extends MovieClip {
		private var gravity:Number = .4;
		private var vy:Number = 0;
		private var vx:Number = 0;
		private var key:KeyObject;
		private var stageRef:Stage;

		private var maxspeedG:Number = 9;
		private var maxspeed:Number = 6;

		private var friction:Number = .92;
		private var MouseDown:Boolean;
		public function helicopter(stageRef:Stage):void {
			this.stageRef =stageRef;
			dispatchEvents();
			addEventListener(Event.ENTER_FRAME, loop, false, 0, true);
			key = new KeyObject(stageRef);
			x = stageRef.stageWidth/2;
			y = stageRef.stageHeight/2;
			
		}
		public function dispatchEvents() {
			this.stageRef .addEventListener(MouseEvent.MOUSE_DOWN,eventtrue);
			this.stageRef .addEventListener(MouseEvent.MOUSE_UP,eventfalse);
		}
		private function eventtrue(e:MouseEvent) {
			MouseDown=true;
		}
		private function eventfalse(e:MouseEvent) {
			MouseDown=false;
		}
		public function loop(e:Event):void {
			vy += gravity;
			y += vy;
			x += vx;

			if (vy > maxspeedG) {
				vy = maxspeedG;
			} else if (vy < -maxspeed) {
				vy = -maxspeed;

			}
			if (vx > maxspeed) {
				vx = maxspeed;
			} else if (vx < -maxspeed) {
				vx = -maxspeed;

			}
			if (y > stageRef.stageHeight) {
				y = stageRef.stageHeight;
				vy = 0;
			}
			rotation = vx*2;

			if (key.isDown(Keyboard.RIGHT)) {
				vx += .5;
			} else if (key.isDown(Keyboard.LEFT)) {
				vx -= .5;
			} else {
				vx *= friction;

			}

			if (MouseDown) {
				vy -= 1;
			} else if (!MouseDown) {
				vy += .5;

			}

		}
	}
}